//	Tip Server
//	(C) 2003 Troeglazov Gerasim aka 3dEyes**

#include <Application.h>
#include <be/interface/Font.h>
#include <Window.h>
#include <Alert.h>
#include <Button.h>
#include <unistd.h>
#include <Bitmap.h>
#include <Screen.h>
#include "Tip.h"


BTipView::BTipView(BRect frame):BView(frame,"View",B_FOLLOW_NONE,B_WILL_DRAW)
{
	Back=NULL;
}

void BTipView::AttachedToWindow()
{
}

void BTipView::Draw(BRect upRect)
{
 	if(Text!=NULL)
 	{
	 	BFont font(be_plain_font);
	 	font.SetSize(11.0);
	 	font.SetFlags(B_DISABLE_ANTIALIASING);
	 	SetFont(&font,B_FONT_SIZE|B_FONT_FLAGS);
 		Width=StringWidth(Text)+20;
 		BRect rect=Window()->Bounds();

		SetDrawingMode(B_OP_COPY);
		if(Back!=NULL)DrawBitmap(Back,BPoint(0,0));
		SetDrawingMode(B_OP_ALPHA);
			
		for(int y=0;y<16;y++){SetHighColor(255-y*3,200-y*3,64-y*3,210);StrokeLine(BPoint(0,y),BPoint(rect.Width()-4,y));}
		for(int y=16;y<21;y++){SetHighColor(50,50,50,90);StrokeLine(BPoint(4,y),BPoint(rect.Width(),y));}
		for(int y=4;y<16;y++){SetHighColor(50,50,50,90);StrokeLine(BPoint(rect.Width()-4,y),BPoint(rect.Width(),y));}
 		SetHighColor(0,0,0);DrawString(Text,BPoint(10,12));	
 		SetHighColor(0,0,0);StrokeRect(BRect(rect.left,rect.top,rect.right-4,rect.top+16));
	}	
}

//------------------------------------------------------------------------------

int32 
BTipPulseFunc(void *tip)
{
	BTip *t=(BTip*)tip;
	int	 Count=0;	
	for(;;)
	{
	 snooze(10000);
	 if(t->ShowFlag==1)Count++;

	 if(Count>120)
	 	{
		 	t->LockLooper();
		 	t->MoveTo(t->Where.x,t->Where.y);
		 	t->UnlockLooper();
		}
	 if(Count>350)t->ShowFlag=0;

	 if(t->ShowFlag==0)
	 {
 		Count=0;
	 	t->LockLooper();
		t->MoveTo(0,-30);
		t->UnlockLooper();
	 }
	}
}

//------------------------------------------------------------------------------
BTip::BTip(void):BWindow(BRect(0,0,0,0),"Tip",B_NO_BORDER_WINDOW_LOOK,B_FLOATING_ALL_WINDOW_FEEL,B_NOT_RESIZABLE|B_NOT_ZOOMABLE)
{
	fBView = new BTipView(BRect(0,0,256,21));	
	fBView->Text[0]=0;
	ShowFlag=0;
	Lock();
	AddChild(fBView);
	MoveTo(0,-30);
	Unlock();
	Show();
	EnableFlag=true;

	BTip *t=(BTip*)this;
 	pulse=spawn_thread(BTipPulseFunc,"TipPulseFunc",B_NORMAL_PRIORITY,(void*)t);
 	resume_thread(pulse);
}

BTip::~BTip(void)
{
	suspend_thread(pulse);
	kill_thread(pulse);
}

bool BTip::QuitRequested()
{
	suspend_thread(pulse);
	kill_thread(pulse);
 	BWindow::Quit();
	return true;
}

void 
BTip::Enable(bool f)
{
	EnableFlag=f;
}

void
BTip::Go(BPoint point,char *Text)
{
	if(ShowFlag==1 || EnableFlag==false)return;
	
	BScreen *scr=new BScreen();
	strcpy(fBView->Text,Text);
 	BFont font(be_plain_font);font.SetSize(11.0);
 	float Width=font.StringWidth(Text)+20+4;
 	if(point.x+Width>scr->Frame().right)point.x=scr->Frame().right-Width;
 	if(point.y+20>scr->Frame().bottom)point.y=scr->Frame().bottom-20;

 	LockLooper();
	BRect r=BRect(point.x,point.y,point.x+Width,point.y+22);
	BBitmap *bmp;
	BBitmap *old=fBView->Back;
	scr->GetBitmap(&bmp,false,&r);
	fBView->Back=bmp;
	if(old!=NULL)delete old;
	UnlockLooper();
		
	Where=point;
	MoveTo(0,-20);
 	ResizeTo(Width,19);
 	ShowFlag=1;
 	scr->~BScreen();
}

void 
BTip::Stop(void)
{
	ShowFlag=0;
}
